<script lang="tsx">
import { Vue, Component, Prop } from 'vue-property-decorator'

import _ from 'lodash/fp'

export default Vue.extend({
  functional: true,

  props: {
    rules: { type: Array, required: true }
  },

  render (h, { props }) {
    const renderSet = ([rule, ruleType]) => (
      <div>
        <div>
          <span class='text-xs'>
            { rule.dimensionName }
          </span>
          { ruleType === 'inSet' ? ' in' : ' NOT in' }
        </div>

        { _.map((value) => (
          <ul style='list-style: "– "'>
            <li>
              { value }
            </li>
          </ul>
        ), (rule[ruleType])) }
      </div>
    )

    const renderInterval = ([rule, ruleType]) => (
      <div>
        <div>
          <span class='text-xs'>
            { rule.dimensionName }
          </span>
          between
          { ruleType === 'inInterval' ? ' between' : ' NOT between' }
        </div>

        <ul style='list-style: "– "'>
          <li>
            { rule[ruleType][0] }
          </li>
          and
          <li>
            { rule[ruleType][1] }
          </li>
        </ul>
      </div>
    )

    const renderSingle = ([rule, ruleType]) => (
      <div>
        <span class='text-xs'>
          { rule.dimensionName }
        </span>

        { ruleType === 'greater than' ? ' greater than' : ' lower than' }
        { rule[ruleType] }
      </div>
    )

    const renderThemes = ([rule, ruleType]) => (
      <div>
        <div>
          <span class='text-xs'>
            { rule.dimensionName }
          </span>
          { ' has' }
        </div>

        { _.map((value) => (
          <ul style='list-style: "– "'>
            <li>
              { value }
            </li>
          </ul>
        ), (rule[ruleType])) }
      </div>
    )

    const renderRule = ([rule, ruleType]) => (
      <li
        key={ rule.dimensionName }
        class='my-4'
      >
        {
          (() => {
            switch (ruleType) {
              case 'inSet':
              case 'outSet':
                return renderSet
              case 'contain_themes':
                return renderThemes
              case 'inInterval':
              case 'outInterval':
                return renderInterval
              case 'greaterThan':
              case 'lowerThan':
              default:
                return renderSingle
            }
          })()([rule, ruleType])
        }
      </li>
    )

    return (
      <div>
        <ul class='list-reset'>
          { _.map(renderRule, props.rules)}
        </ul>
      </div>
    )
  }
})
</script>
